import org.kwis.msp.lcdui.*;
import java.util.*;

public class ProjectEx extends Jlet
{
	protected void startApp(String args[])
	{
		Display dp = Display.getDefaultDisplay();
		dp.pushCard(new Start());
	}


	protected void destroyApp(boolean b){}
}

class Start extends Card
{
	// θ޴ ================================
	public static final int		MODE_MENU	=0;
	public static final int		MODE_CAL	=1;
	public static final int		MODE_TEST	=2;
	public static final int		MODE_CAN	=3;

	// ====================================
	public static final int		CAL_NUM1    =0;
	public static final int		CAL_NUM2    =1;
	public static final int		CAL_MAX     =6;
	public static final int		TOTAL_0     =0;
	public static final int		TOTAL_1     =1;

	int state;
	int cal_state;
	int total_state;
	int alcol_point;
	int alcol_state;

	Font font;
	String num1_st, num2_st;
	int cal_count;
	char cal;
	long num1, num2, total;

	public Start()
	{
		state       = MODE_MENU;
		cal_state   = CAL_NUM1;
	    total_state = TOTAL_0;
		alcol_point = 0;
		alcol_state = 0;

		num1_st     = "0";
		num2_st     = "0";

		cal_count   = 0;
		num1        = 0;
		num2        = 0;
		total       = 0;
	}

	public void paint(Graphics g)
	{
		switch (state)			
		{
			case MODE_MENU:	
				StartMenu(g);
			break;

			case MODE_CAL:
				Calculator(g);
			break;
			
			case MODE_TEST:
				AlcolTest(g);	
			break;
		}
	}

	public boolean keyNotify(int type, int key)
	{
		if(state == MODE_MENU && type == EventQueue.KEY_PRESSED)
		{
			switch(key)
			{
				case EventQueue.KEY_NUM1:
					state = MODE_CAL;
				break;

				case EventQueue.KEY_NUM2:
					state = MODE_TEST;
				break;

				case EventQueue.KEY_NUM3:
					state = 3;
				break;

				case EventQueue.KEY_NUM4:
					state = 4;
				break;
			}
			repaint();
		}

		else if(state == MODE_CAL && type == EventQueue.KEY_PRESSED)
		{
			switch(key)
			{
				case EventQueue.KEY_NUM1:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "1";
						else if(cal_count < CAL_MAX)
							num1_st += 1;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "1";
						else if(cal_count < CAL_MAX)
							num2_st += 1;
					}
					cal_count++;
				break;

				case EventQueue.KEY_NUM2:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "2";
						else if(cal_count < CAL_MAX)
							num1_st += 2;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "2";
						else if(cal_count < CAL_MAX)
							num2_st += 2;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM3:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "3";
						else if(cal_count < CAL_MAX)
							num1_st += 3;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "3";
						else if(cal_count < CAL_MAX)
							num2_st += 3;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM4:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "4";
						else if(cal_count < CAL_MAX)
							num1_st += 4;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "4";
						else if(cal_count < CAL_MAX)
							num2_st += 4;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM5:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "5";
						else if(cal_count < CAL_MAX)
							num1_st += 5;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "5";
						else if(cal_count < CAL_MAX)
							num2_st += 5;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM6:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "6";
						else if(cal_count < CAL_MAX)
							num1_st += 6;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "6";
						else if(cal_count < CAL_MAX)
							num2_st += 6;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM7:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "7";
						else if(cal_count < CAL_MAX)
							num1_st += 7;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "7";
						else if(cal_count < CAL_MAX)
							num2_st += 7;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM8:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "8";
						else if(cal_count < CAL_MAX)
							num1_st += 8;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "8";
						else if(cal_count < CAL_MAX)
							num2_st += 8;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM9:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "9";
						else if(cal_count < CAL_MAX)
							num1_st += 9;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "9";
						else if(cal_count < CAL_MAX)
							num2_st += 9;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_NUM0:
					if(cal_state==CAL_NUM1)
					{
						if(cal_count == 0)
							num1_st = "0";
						else if(cal_count < CAL_MAX)
							num1_st += 0;
					}
					else
					{
						if(cal_count == 0)
							num2_st = "0";
						else if(cal_count < CAL_MAX)
							num2_st += 0;
					}
					cal_count++;
				break;
				
				case EventQueue.KEY_STAR:
					CalInit();
				break;
				
				case EventQueue.KEY_POUND:
					CalInit();
					state = MODE_MENU;
				break;		
			}

			switch(Display.getGameAction(key))
			{				
				case EventQueue.FIRE: //
					num1 = Integer.parseInt(num1_st);
					num2 = Integer.parseInt(num2_st);
					switch(cal)
					{
						case '+':
							total = num1 + num2;
						break;

						case '-':
							total = num1 - num2;
						break;
						case '*':
							total = num1 * num2;
						break;
						case '/':
							total = num1 / num2;
						break;
					}
					total_state = TOTAL_1;
					cal_count = 0;
					break;
				case EventQueue.UP:
					cal = '+';
					cal_state = CAL_NUM2;
					cal_count = 0;
					break;
				case EventQueue.DOWN:
					cal = '-';
					cal_state = CAL_NUM2;
					cal_count = 0;
					break;
				case EventQueue.RIGHT:
					cal = '*';
					cal_state = CAL_NUM2;
					cal_count = 0;
					break;
				case EventQueue.LEFT:
					cal = '/';
					cal_state = CAL_NUM2;
					cal_count = 0;
					break;

			}
			repaint();
		}
		else if(state == MODE_TEST && type == EventQueue.KEY_PRESSED)
		{
			if(alcol_state == 0 && key == EventQueue.KEY_STAR)
			{
				alcol_point = 0;
				alcol_state = 1;
			}
			else if(alcol_state == 0 && key == EventQueue.KEY_POUND)
			{
				alcol_point = 0;
				alcol_state = 0;
				state = MODE_MENU;
			}
			else if(alcol_state > 0)
			{
				switch(key)
				{
					case EventQueue.KEY_NUM1:
						alcol_point += 0;
						alcol_state++;
					break;
					case EventQueue.KEY_NUM2:
						alcol_point += 1;
						alcol_state++;
					break;
					case EventQueue.KEY_NUM3:
						alcol_point += 2;
						alcol_state++;
					break;
					case EventQueue.KEY_NUM4:
						alcol_point += 3;
						alcol_state++;
					break;
					case EventQueue.KEY_NUM5:
						alcol_point += 4;
						alcol_state++;
					break;
				}
			}
			repaint();
		}
		return true;
	}

	public void StartMenu(Graphics g)
	{
		Image img = null;

		g.setColor(0x00A0F3);
		g.fillRect(0,0,getWidth(),getHeight());
		g.setColor(0xffffff);
		g.fillRect(3,3,getWidth()-6,getHeight()-6);
		try
		{
			img = Image.createImage("/img/start_menu.png");
		}catch(Exception e){}
		g.drawImage(img,10,4,g.LEFT);

		font = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD,Font.SIZE_SMALL);
		g.setFont(font);
		g.setColor(0x317194);
		g.drawString("1. WIPI "  , 15,   60, g.LEFT);
		g.drawString("2.  ׽Ʈ"  , 15,   80, g.LEFT);
		g.drawString("3. ī "    , 15,  100, g.LEFT);
		g.drawString("4.  ð"    , 15,  120, g.LEFT);
	}

	public void CalInit()
	{
		cal_state = 0; 
		total_state = 0;
		num1_st = "0";	
		num2_st = "0";
		num1 = 0;	
		num2 = 0;	
		total = 0;
		cal_count = 0;
	}

	public void Calculator(Graphics g)
	{
		Image img = null;

		g.setColor(0xffffff);
		g.fillRect(0,0,getWidth(),getHeight());
		g.setColor(0x00A0F3);
		g.fillRect(0,0,getWidth(),20);
		g.setColor(0x90D9FF);
		g.fillRect(0,21,getWidth(),getHeight()-65);
		g.setColor(0xFF7E00);
		g.fillRect(5,65,getWidth(),2);
		font = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD,Font.SIZE_SMALL);
		g.setFont(font);
		g.setColor(0x000000);
		g.drawString("WIPI " , getWidth()/2,  5, g.HCENTER);
		try
		{
			img = Image.createImage("/img/cal_menu.png");
		}catch(Exception e){}

		g.drawImage(img,0,(getHeight()-65),g.LEFT);

		g.drawString(num1_st , getWidth()-5,22,g.RIGHT);
		if(cal_state == CAL_NUM2)
		{
			g.setColor(0xFF0000);
			g.drawString(String.valueOf(cal), 20,35,g.LEFT);
			g.setColor(0x000000);
			g.drawString(num2_st , getWidth()-5,48,g.RIGHT);
		}
		if(total_state == TOTAL_1 )
			g.drawString(String.valueOf(total), getWidth()-5,75,g.RIGHT);
	}

	public void AlcolTest(Graphics g)
	{
		Image img = null;
		String subject[]={"躸Ǳⱸ"," ", "ڰ  "};

		g.setColor(0xffffff);
		g.fillRect(0,0,getWidth(),getHeight());
		g.setColor(0xFF6600);
		g.fillRect(0,0,getWidth(),20);
		font = Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_BOLD,Font.SIZE_SMALL);
		g.setFont(font);
		g.setColor(0x000000);
		g.drawString(" ׽Ʈ" , getWidth()/2,  5, g.HCENTER);


		if(alcol_state == 0)
		{
			g.drawString(subject[0] , getWidth()/2,  40, g.HCENTER);
			g.drawString(subject[1] , getWidth()/2,  60, g.HCENTER);
			g.drawString(subject[2] , getWidth()/2,  80, g.HCENTER);
			g.setColor(0xFFFF99);
			g.fillRect(0,getHeight()-25,getWidth(),getHeight());
			g.setColor(0x444444);
			g.drawString("*    # ޴" , getWidth()/2,  getHeight()-20, g.HCENTER);
		}
		else if(alcol_state == 1)
		{
			try{
				img = Image.createImage("/img/test_qa01.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 2)
		{
			try{
				img = Image.createImage("/img/test_qa02.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 3)
		{
			try{
				img = Image.createImage("/img/test_qa03.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 4)
		{
			try{
				img = Image.createImage("/img/test_qa04.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 5)
		{
			try{
				img = Image.createImage("/img/test_qa05.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 6)
		{
			try{
				img = Image.createImage("/img/test_qa06.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 7)
		{
			try{
				img = Image.createImage("/img/test_qa07.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 8)
		{
			try{
				img = Image.createImage("/img/test_qa08.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 9)
		{
			try{
				img = Image.createImage("/img/test_qa09.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else if(alcol_state == 10)
		{
			try{
				img = Image.createImage("/img/test_qa10.png");
			}catch(Exception e){}
			g.drawImage(img,0,22,g.LEFT);
		}
		else
		{
			if(alcol_point >=25)
			{
				g.drawString("", getWidth()/2,  40, g.HCENTER);
				g.drawString(" ߵ!", getWidth()/2,  60, g.HCENTER);
			}
			else if(alcol_point >=15)
			{
				g.drawString("", getWidth()/2,  40, g.HCENTER);
				g.drawString(" !", getWidth()/2,  60, g.HCENTER);
			}
			else if(alcol_point >=12)
			{
				g.drawString("", getWidth()/2,  40, g.HCENTER);
				g.drawString(" !", getWidth()/2,  60, g.HCENTER);
			}
			else
			{
				g.drawString("", getWidth()/2,  40, g.HCENTER);
				g.drawString(" !", getWidth()/2,  60, g.HCENTER);
			}

			alcol_state = 0;

			g.setColor(0xFFFF99);
			g.fillRect(0,getHeight()-25,getWidth(),getHeight());
			g.setColor(0x444444);
			g.drawString("* ó  # ޴" , getWidth()/2,  getHeight()-20, g.HCENTER);
		}
	}
}